<?php
//////////////////////////////////////////////////////////////////////
// MyHeadlines v4.0.6, July 28, 2002
// by:  Mike Agar
//      www.jmagar.com
//////////////////////////////////////////////////////////////////////
// This code is released under GPL refer to the included license.txt
//////////////////////////////////////////////////////////////////////
global $myhPath;

/**********************************************************************
Security Fix:  $myhPath must be a local path!  No external resources!!!
*/
$securityCheck = parse_url($myhPath);
if(isset($securityCheck["scheme"])){
    die("Goodbye.");
}

//Not happy with this one... include_once("$myhPath/include/usefulinc/rss10.php");
//Trying M. Lemos code base instead...
include_once("$myhPath/include/mlemos/xml_writer_class.php");
include_once("$myhPath/include/mlemos/rss_writer_class.php");

class myh_backend {
    var $MYH_DEBUG;
    var $prefixURL;
    var $tableName;
        
    ///////////////////////////////////////////////////////////////////
	// Constructor / INIT Functions
	function myh_backend($url,$tn = "backend",$dbg=0){
		$this->MYH_DEBUG = $dbg;
		$this->prefixURL = $url;
		$this->tableName = $tn;
	}

    function rssOutput($myh_pd,$data,$vers="0.91"){
        global $myhPath,$HTTP_SERVER_VARS;

    	/*
    	 *  First create an object of the class.
    	 */
    	$rss_writer_object=new rss_writer_class;
    
    	/*
    	 *  Choose the version of specification that the generated RSS document should conform.
    	 */
    	$rss_writer_object->specification=$vers;
    
    	/*
    	 *  Specify the URL where the RSS document will be made available.
    	 */
        $rss_url  = "http://".$HTTP_SERVER_VARS["SERVER_NAME"].$HTTP_SERVER_VARS["REQUEST_URI"];
    	$rss_writer_object->about=$rss_url;//="http://www.phpclasses.org/channels.xml";
    
    	/*
    	 *  Specify the URL of an optional XSL stylesheet.
    	 *  This lets the document be rendered automatically in XML capable browsers
    	 *  such as Internet Explore 5, Mozilla 5/Netscape 6 or better.
    	 */
    	$rss_style  = "http://".$HTTP_SERVER_VARS["SERVER_NAME"];
        $rss_style .= substr($HTTP_SERVER_VARS["SCRIPT_NAME"],0,strlen($HTTP_SERVER_VARS["SCRIPT_NAME"])-(strlen($HTTP_SERVER_VARS["SCRIPT_NAME"])-strrpos($HTTP_SERVER_VARS["SCRIPT_NAME"],"/"))); 
        $rss_style .= "/".$myhPath."/include/mlemos/rss2html.xsl";
    	
    	//$rss_writer_object->stylesheet=$rss_style;
    
    	/*
    	 *  Define the properties of the channel.
    	 */
    	$properties=array();
    	$properties["description"]=$data["siteDesc"];
    	$properties["link"]=$data["siteURL"];
    	$properties["title"]=$data["siteName"];
    	switch($vers){
    	   case "0.91":  	
            	$properties["language"]="en";
            	break;
            default:
                break;
    	}
    	$rss_writer_object->addchannel($properties);
    
    	/*
    	 *  If your channel has a logo, before adding any channel items, specify the logo details this way.
    	 */
    	$properties=array();
        $properties["url"]=$myh_pd->getValue("default_backend_image");
    	$properties["link"]=$data["siteURL"];
    	$properties["title"]=$data["siteName"];
    	$properties["description"]=$data["siteDesc"];
    	$rss_writer_object->addimage($properties);
    
    	/*
    	 *  Then add your channel items one by one.
    	 */
        $end = count($data["items"]);
        $properties=array();
    	for($loop=0;$loop<$end;$loop++){
            $properties["description"]=$data["items"][$loop]->description;
        	$properties["link"]=$data["items"][$loop]->link;
        	$properties["title"]=$data["items"][$loop]->title;
        	$rss_writer_object->additem($properties);
        }

    	/*
    	 *  If your channel has a search page, after adding the channel items, specify a search form details this way.
    	 */
    	$properties=array();
    
    	/*
    	 *  The name property if the name of the text input form field on which the user will enter the search word.
    	 */
        $rss_search  = "http://".$HTTP_SERVER_VARS["SERVER_NAME"];
        $rss_search .= substr($HTTP_SERVER_VARS["SCRIPT_NAME"],0,strlen($HTTP_SERVER_VARS["SCRIPT_NAME"])-(strlen($HTTP_SERVER_VARS["SCRIPT_NAME"])-strrpos($HTTP_SERVER_VARS["SCRIPT_NAME"],"/"))); 
    	$rss_search .= "/".$this->prefixURL."&myh=user&myh_op=search";
    	$properties["name"]="myh_search";
    	$properties["link"]=$rss_search;
    	$properties["title"]="Search:";
    	$properties["description"]="Search Form";
    	//$rss_writer_object->addtextinput($properties);
    	
    	/*
    	 *  When you are done with the definition of the channel items, generate RSS document.
    	 */
    	if($rss_writer_object->writerss($output))
    	{
    		
    		/*
    		 *  If the document was generated successfully, you may not output it.
    		 */
    		Header("Content-Type: text/xml; charset=\"".$rss_writer_object->outputencoding."\"");
    		Header("Content-Length: ".strval(strlen($output)));
    		echo $output;
    	}
    	else
    	{
    
    		/*
    		 *  If there was an error, output it as well.
    		 */
    		Header("Content-Type: text/plain");
    		echo ("Error: ".$rss_writer_object->error);
    	}
    }

    function getCacheData($myh_pd,$myh_src,$myh_cache,$sid){
        $data = array();
        $data["siteURL"] = $myh_src->getURL($sid);
        $data["siteName"] = $myh_src->getTitle($sid);
        $data["siteDesc"] = $myh_src->getComment($sid);
        $data["items"] = array();

		$items = $myh_cache->getItems($sid);
		$not_done = $myh_pd->getValue("rss_max_items");
		while(list($cid,$iser, $timeout) = @current($items)){
			if($not_done){
				$data["items"][] = unserialize($iser);
			}else{
        		return $data;
			}
			$not_done--;
			next($items);
		}
/*
		$end = count($data["items"]);
		for($loop=0;$loop<$end;$loop++){
		    $data["items"][$loop]->description = $this->unscrub($data["items"][$loop]->description);    
		}
*/
		return $data;
		
    }

    function export($myh_gtu,$myh_cat,$myh_src,$myh_catTree){
        global $myh_include, $myh_exclude, $myh_scraped_only;
        
        echo $myh_catTree->myhExport($myh_gtu,$myh_src,$myh_cat,$myh_include,$myh_exclude,0,isset($myh_scraped_only));
    }

    function permit($myh_pd){
        //TODO: make this work...
        return $myh_pd->getValue("allow_backend_access");   
    }

    function preProcessing($myh_pd,$myh_gtu,$myh_cat,$myh_src,$myh_cache,$myh_catTree,$MyHeadlines){
		global $myh_op,$myh_search,$myh_sid,$myh_account,$myh_sect;
		
		$restore_menu = 0;
		if($this->MYH_DEBUG)echo "backendPreProcessing(): op = $myh_op<br>\n";
		if($this->permit($myh_pd)){
    		switch($myh_op){
                case "export":
                    @set_time_limit(3600);
                    $this->export($myh_gtu,$myh_cat,$myh_src,$myh_catTree);
                    break;
                case "rss0.9":
                    $data = $this->getCacheData($myh_pd,$myh_src,$myh_cache,$myh_sid);
                    $this->rssOutput($myh_pd,$data,"0.91");
                    flush();
                    $MyHeadlines->updateCache($myh_sid);
                    break;
                case "rss": //default
                case "rss91": //default
                case "rss0.91":
                    $data = $this->getCacheData($myh_pd,$myh_src,$myh_cache,$myh_sid);
                    $this->rssOutput($myh_pd,$data,"0.91");
                    flush();
                    $MyHeadlines->updateCache($myh_sid);
                    break;
                case "rss1.0":
                case "rss10":
                    $data = $this->getCacheData($myh_pd,$myh_src,$myh_cache,$myh_sid);
                    $this->rssOutput($myh_pd,$data,"1.0");
                    flush();
                    $MyHeadlines->updateCache($myh_sid);
                    break;
                case "section":
    			    $data = $this->getSection($myh_sect,$myh_pd,$myh_cache);
    			    $this->rssOutput($myh_pd,$data);
                    break;
    			case "latest":
    			    $data = $this->latest($myh_pd,$myh_src,$myh_cache);
    			    $this->rssOutput($myh_pd,$data);
                    break;
    			case "topten":
    			    $data = $this->topten($myh_pd,$myh_src,$myh_cache);
    			    $this->rssOutput($myh_pd,$data);
                    break;
    			case "tts":
    			    $data = $this->toptenSrcs($myh_pd,$myh_src,$myh_cache);
    			    $this->rssOutput($myh_pd,$data);
                    break;
    			case "search":
    			    $data = $this->search($myh_pd,$myh_src,$myh_cache,$myh_search);
    			    $this->rssOutput($myh_pd,$data);
                    break;
    			case "cron":
                    echo "<head><meta http-equiv=\"refresh\" content=\"600;".$myh_pd->getValue("cron_url")."\"></head><body>";
                    flush(); 
                    echo $MyHeadlines->refreshExpired();
                    echo "</body>";
                    break;
                default:
                    break;
    		}
		}else{//Always allow cron job...
    		switch($myh_op){
    			case "cron":
                    echo "<head><meta http-equiv=\"refresh\" content=\"600;".$myh_pd->getValue("cron_url")."\"></head><body>";
                    flush(); 
                    echo $MyHeadlines->refreshExpired();
                    echo "</body>";
                    break;
                default:
                    break;
    		}
        
        }
		die(); //All backend functions die here!, nothing else is done.
    }


    function latest($myh_pd,$myh_src,$myh_cache){
        global $myhPath;
        
        $results = $myh_cache->latest($search);
        $end = count($results);
        $dFormat = $myh_pd->getValue("date_format");
        $output = array();

        $output["siteName"] = $myh_pd->getValue("default_backend_title");
        $output["siteDesc"] = $myh_pd->getValue("default_backend_description");
        $output["siteURL"] = $myh_pd->getValue("default_backend_link");
        $output["items"]=array();
        for($loop=0; $loop<$end; $loop++){
        	$back = $results[$loop];
        	$sourceID = $back["sid"];
        	$sourceName = $myh_src->getTitle($back["sid"]);
        	$item = unserialize($back["iser"]);
        	$stamp = date($dFormat,$back["time"]);
//        	$url = $this->getClickThruURL($back["cid"]);
        	$title = $item->title;
        	$score = 1.0*((int)($back["score"]*10000.0)/10000);
          	if(strlen($item->description)>4){
        		$description = $this->scrub($item->description);
        	}else{
        	    $description = "";  //$stamp." ".$sourceName;   
        	}
        	$item->title = $this->scrub($title);
//        	$item->link = $this->scrub($url);
        	$item->description = $this->scrub($description);
        	//TODO: REMOVE "SEARCH" type of source items...
        	$output["items"][]=$item;
        }
        return $output;        
    }

    function topten($myh_pd,$myh_src,$myh_cache){
        global $myhPath;
        $results = $myh_cache->topTenItems();

        $end = count($results);
        $dFormat = $myh_pd->getValue("date_format");
        $output = array();

        $output["siteName"] = $myh_pd->getValue("default_backend_title");
        $output["siteDesc"] = $myh_pd->getValue("default_backend_description");
        $output["siteURL"] = $myh_pd->getValue("default_backend_link");
        $output["items"]=array();
        for($loop=0; $loop<$end; $loop++){
        	$back = $results[$loop];
        	$sourceID = $back["sid"];
        	$sourceName = $myh_src->getTitle($back["sid"]);
        	$item = unserialize($back["iser"]);
        	$stamp = date($dFormat,$back["time"]);
//        	$url = $this->getClickThruURL($back["cid"]);
        	$title = $item->title;
        	$score = 1.0*((int)($back["score"]*10000.0)/10000);
          	if(strlen($item->description)>4){
        		$description = $this->scrub($item->description);
        	}else{
        	    $description = "";  //$stamp." ".$sourceName;   
        	}
        	$item->title = $this->scrub($title);
//        	$item->link = $this->scrub($url);
        	$item->description = $this->scrub($description);
        	//TODO: REMOVE "SEARCH" type of source items...
        	$output["items"][]=$item;
        }
        return $output;        
    }
    

    function toptenSrcs($myh_pd,$myh_src,$myh_cache){
        global $myhPath;
        $results = $myh_src->subsCount();

        $allSrcs = array_keys($results);
		
		$limit = $myh_pd->getValue("num_search_results_per_page");

        return $this->getMultiSource($myh_pd->getValue("default_backend_title"),$allSrcs,$limit,$myh_pd,$myh_cache);    

   }



    function search($myh_pd,$myh_src,$myh_cache,$search){
        global $myhPath;
        
        $results = $myh_cache->search($search);
        $end = count($results);
        $dFormat = $myh_pd->getValue("date_format");
        $output = array();
        $output["siteName"] = $search;
        $output["siteDesc"] = $search;
        $output["siteURL"] = $this->prefixURL."&meid=503&myh=user&myh_op=search&myh_search=\"".$search."\"";
        $output["items"]=array();
        for($loop=0; $loop<$end; $loop++){
        	$back = $results[$loop];
        	$sourceID = $back["sid"];
        	$sourceName = $myh_src->getTitle($back["sid"]);
        	$item = unserialize($back["iser"]);
        	$stamp = date($dFormat,$back["time"]);
//        	$url = $this->getClickThruURL($back["cid"]);
        	$title = $item->title;
        	$score = 1.0*((int)($back["score"]*10000.0)/10000);
          	if(strlen($item->description)>4){
        		$description = $this->scrub($item->description);
        	}else{
        	    $description = "";  //$stamp." ".$sourceName;   
        	}
        	$item->title = $this->scrub($title);
//        	$item->link = $this->scrub($url);
        	$item->description = $this->scrub($description);
        	//TODO: REMOVE "SEARCH" type of source items...
        	$output["items"][]=$item;
        }
        return $output;        
    }

	function getClickThruURL($cid){
		$url = $this->prefixURL."&myh=user&myh_op=click&cid=$cid";
		return $url;
	}


	function scrub($dirty){
		$clean = urldecode($dirty);
		$clean = urldecode($clean);
		$clean = urldecode($clean);
		$clean = eregi_replace("&amp;","&", $clean); 
		$clean = eregi_replace("&amp;","&", $clean); 
		$clean = eregi_replace("&amp;","&", $clean); 
		$clean = eregi_replace("<", "&lt;", $clean); 
		$clean = eregi_replace(">", "&gt;", $clean); 
		$clean = eregi_replace("\"", "&quot;", $clean); 
		$clean = eregi_replace("\\\'", "&apos;", $clean); 		
		$clean = eregi_replace("'", "&apos;", $clean);
		return $clean;
	}
	
	function unscrub($clean){
		$dirty = urldecode($clean);
		$dirty = urldecode($dirty);
		$dirty = urldecode($dirty);
		$dirty = eregi_replace("&amp;","&", $dirty); 
		$dirty = eregi_replace("&amp;","&", $dirty); 
		$dirty = eregi_replace("&amp;","&", $dirty); 
		$dirty = eregi_replace("&lt;","<", $dirty); 
		$dirty = eregi_replace("&gt;",">", $dirty); 
		$dirty = eregi_replace("&quot;","\"", $dirty); 
		$dirty = eregi_replace("&apos;","'", $dirty); 		
		$dirty = eregi_replace("\\\'","'", $dirty); 		
		return $dirty;	
	}


    function getSection($sectId,$myh_pd,$myh_cache){
        //get list of sources
        global $eid,$myhPath,$myh_sect;


        //Sections
        $sects = new agar_section($myh_pd->getValue("table_prefix")."_sect",$this->MYH_DEBUG);
        $section = new myh_section;
        $section->id = $myh_sect;
        $section = $sects->getSection($section);

        //Srcs
        $allSrcs = $sects->getSectionSrcs($section); //array of sids
		$limit = $myh_pd->getValue("num_search_results_per_page");

        return $this->getMultiSource($section->name,$allSrcs,$limit,$myh_pd,$myh_cache);    
    }


    function getMultiSource($sName,$sidArray,$limit,$myh_pd,$myh_cache){
        $data = array();


        $data["siteDesc"] = $myh_pd->getValue("default_backend_description");
        $data["siteURL"] = $myh_pd->getValue("default_backend_link");
        $data["siteName"] = $sName;
        $data["items"] = array();

		$items = $myh_cache->getMultiSrcItems($sidArray, $limit);
		while(list($cid,$iser, $timeout) = @current($items)){
			$data["items"][] = unserialize($iser);
			next($items);
		}
		return $data;
    }

}

?>